/******************************************************************************
***
***				COPYRIGHT
***
***	Die Daten in dieser Datei sind Eigentum der 
***
***	YARD Software GmbH, 51107 Koeln, Deutschland.
***
***	Diese Datei gilt als Werk im Sinne des Urheberrechtsgesetzes und ist
***	damit urheberrechtlich geschuetzt. Jede Verwertung, insbesondere die
***	Vervielfaeltigung, Aenderung und Weitergabe, auch auszugsweise,
***	ist nur mit ausdruecklicher schriftlicher Genehmigung der YARD
***	Software GmbH zulaessig.
***
***	Ebenso ist die Speicherung dieser Datei auf Datentraegern wie z.B.
***	Festplatten, Disketten, Magnetbaendern, CDs und aehnlichen, auch 
***	auszugsweise, nur mit ausdruecklicher schriftlicher Genehmigung der 
***	YARD Software GmbH zulaessig.
***
***	Zuwiderhandlungen unterliegen den Strafbestimmungen des Urheberrechts-
***	gesetzes.
***
******************************************************************************/

static char *demo1_ec_sccsid = "@(#) demo1.ec 1.1 98/11/05 16:44:29";

/*
**	This program shows the use of a cursor, to select all
**	customers, which have rent a car.
**	
**	PREREQUISITES:
**	
**	The database RENTAL must be installed using 'yarddemo'
**	The environment variable YARDDBS must be set.
*/

#include <stdio.h>

main(int argc, char **argv)
{
/*
**	Hostvariables to hold the
**	select results.
*/
exec sql begin declare section;
	char lname[21];
	char fname[21];
	char state[21];
	char cartype[21];
exec sql end declare section;

	int rowcnt = 0;

	/*
	**	The program will stop in case of an error
	*/
	exec sql whenever sqlerror stop;

	/*
	**	Connect to the database server with user DBA
	**	The DBS name is taken from the environment variable
	**	YARDDBS during connect.
	*/
	exec sql connect user dba;

	/*
	**	Open the database RENTAL
	*/
	exec sql database rental;

	/*
	**	DECLARE a cursor to SELECT all customers, 
	**	which currently have rent a car.
	*/
	exec sql declare c_demo1 cursor for
		select lname, fname, state, t3.cartype
		from customer t1, car t2, cartype t3, rental t4, state t5
		where t1.customer_no = t4.customer
		and   t1.state_sg = t5.state_sg
		and   t2.car_no = t4.car
		and   t2.cartype = t3.cartype_no
		and   t4.date_return is null;

	/*
	**	Open the cursor
	*/
	exec sql open c_demo1;

	/*
	**	Print a header
	*/
	printf("%-20.20s %-20.20s %-20.20s %-20.20s\n",
		"Last Name",
		"First Name",
		"State",
		"Cartype");

	/*
	**	Fetch the cursor until no more
	**	rows (SQLCODE == SQLNOTFOUND)
	**	will be retrived.
	*/
	for (;;)
	{
		exec sql fetch c_demo1 into
			:lname,
			:fname,
			:state,
			:cartype;
		if (SQLCODE == SQLNOTFOUND)
			break;
		rowcnt++;
		printf("%s %s %s %s\n",
			lname,
			fname,
			state,
			cartype);
	}

	printf("\n%d rows retrieved\n", rowcnt);

	/*
	**	Close the cursor
	*/
	exec sql close c_demo1;

	/*
	**	Close the database
	*/
	exec sql close database;

	/*
	**	Disconnect from database server
	*/
	exec sql disconnect;

	exit(0);
}
