/******************************************************************************
***
***				COPYRIGHT
***
***	Die Daten in dieser Datei sind Eigentum der 
***
***	YARD Software GmbH, 51107 Koeln, Deutschland.
***
***	Diese Datei gilt als Werk im Sinne des Urheberrechtsgesetzes und ist
***	damit urheberrechtlich geschuetzt. Jede Verwertung, insbesondere die
***	Vervielfaeltigung, Aenderung und Weitergabe, auch auszugsweise,
***	ist nur mit ausdruecklicher schriftlicher Genehmigung der YARD
***	Software GmbH zulaessig.
***
***	Ebenso ist die Speicherung dieser Datei auf Datentraegern wie z.B.
***	Festplatten, Disketten, Magnetbaendern, CDs und aehnlichen, auch 
***	auszugsweise, nur mit ausdruecklicher schriftlicher Genehmigung der 
***	YARD Software GmbH zulaessig.
***
***	Zuwiderhandlungen unterliegen den Strafbestimmungen des Urheberrechts-
***	gesetzes.
***
******************************************************************************/

static char *demo2_ec_sccsid = "@(#) demo2.ec 1.1 98/11/05 16:44:29";

/*
**	This program shows the use of the dynamic SQL statements
**	EXECUTE IMMEDIATE and PREPARE & EXECUTE to insert a new row 
**	into tables cartype and car of database rental.
**	
**	PREREQUISITES:
**	
**	The database RENTAL must be installed using 'yarddemo'
**	The environment variable YARDDBS must be set.
**
**	NOTE: The program sets the element sqlclient of the sqlca structure.
**            With this feature the execution of the program is shown
**            by running 'yardstat -uc'
*/

#include <stdio.h>

main(int argc, char **argv)
{
/*
**	Declare some host variables
*/
exec sql begin declare section;
	char cartype_insert[256];
	long cartype;
	char car_insert[256];
exec sql end declare section;

	/*
	**	Set the program name to sqlclient
	*/
	sqlca.sqlclient = argv[0];

	/*
	**	The program will stop in case of an error
	*/
	exec sql whenever sqlerror stop;

	/*
	**	Connect to the database server with user DBA
	**	The DBS name is taken from the environment variable
	**	YARDDBS during connect.
	*/
	exec sql connect user dba;

	/*
	**	Open the database RENTAL
	*/
	exec sql database rental;

	/*
	**	Store the insert statement into a host variable
	*/
	sprintf(cartype_insert, "insert into cartype values \
		(0, '911 Carrera/4', 'Porsche', 320, 1790)");

	/*
	**	Execute the insert statement using
	**	EXECUTE IMMEDIATE
	*/
	exec sql execute immediate :cartype_insert;

	/*
	**	Get the value of the PRIMARY KEY (a SERIAL column)
	**	through the element sqlerrd[1] of the sqlca
	**	structure.
	**	We need this value for the foreign key column of
	**	table car within the following insert.
	*/
	cartype = sqlca.sqlerrd[1];

	/*
	**	Build the insert for table car.
	**
	**	NOTE: For the sake of easyness, the value
	**	      for the foreign key column base (100)
	**            is hard coded.
	**
	**            We also use a dynamic parameter (?)
	**            for the value of column cartype.
	**            The value will be send through the
	**            USING clause of the following
	**            EXECUTE statement.
	*/
	sprintf(car_insert, "insert into car values \
		(0, ?, null, 'K-Y 911', 100)", cartype);

	/*
	**	PREPARE the insert statement
	*/
	exec sql prepare st_car_insert from :car_insert;

	/*
	**	EXECUTE the insert statement and
	**	and transfer the value of cartype
	**	within the USING clause.
	*/
	exec sql execute st_car_insert using :cartype;

	/*
	**	Commit the changes to the database
	*/
	exec sql commit work;

	/*
	**	Close the database
	*/
	exec sql close database;

	/*
	**	Disconnect from database server
	*/
	exec sql disconnect;

	exit(0);
}
