/******************************************************************************
***
***				COPYRIGHT
***
***	Die Daten in dieser Datei sind Eigentum der 
***
***	YARD Software GmbH, 51107 Koeln, Deutschland.
***
***	Diese Datei gilt als Werk im Sinne des Urheberrechtsgesetzes und ist
***	damit urheberrechtlich geschuetzt. Jede Verwertung, insbesondere die
***	Vervielfaeltigung, Aenderung und Weitergabe, auch auszugsweise,
***	ist nur mit ausdruecklicher schriftlicher Genehmigung der YARD
***	Software GmbH zulaessig.
***
***	Ebenso ist die Speicherung dieser Datei auf Datentraegern wie z.B.
***	Festplatten, Disketten, Magnetbaendern, CDs und aehnlichen, auch 
***	auszugsweise, nur mit ausdruecklicher schriftlicher Genehmigung der 
***	YARD Software GmbH zulaessig.
***
***	Zuwiderhandlungen unterliegen den Strafbestimmungen des Urheberrechts-
***	gesetzes.
***
******************************************************************************/

static char *demo3_ec_sccsid = "@(#) demo3.ec 1.1 98/11/05 16:44:29";

/*
**	This program shows the use of a cursor on function, which returns
**	a set of rows (all free cars).
**	The function used is free_cars(), which is part of the
**	demo database RENTAL.
**	
**	PREREQUISITES:
**	
**	The database RENTAL must be installed using 'yarddemo'
**	The environment variable YARDDBS must be set.
*/

#include <stdio.h>

main(int argc, char **argv)
{
/*
**	Hostvariables to hold the
**	select results.
*/
exec sql begin declare section;
	long car_no;
	char manufacturer[11];
	char cartype[21];
exec sql end declare section;

	int rowcnt = 0;

	/*
	**	The program will stop in case of an error
	*/
	exec sql whenever sqlerror stop;

	/*
	**	Connect to the database server with user DBA
	**	The DBS name is taken from the environment variable
	**	YARDDBS during connect.
	*/
	exec sql connect user dba;

	/*
	**	Open the database RENTAL
	*/
	exec sql database rental;

	/*
	**	DECLARE a cursor on a CALL statement to
	**	the stored function available_cars(), 
	**	to get all cars, which are currently available.
	*/
	exec sql declare c_demo3 cursor for
		call available_cars();

	/*
	**	Open the cursor
	*/
	exec sql open c_demo3;

	/*
	**	Print a header
	*/
	printf("A V A I L A B L E  C A R S:\n\n");

	/*
	**	Fetch the procedure cursor until no more
	**	rows (SQLCODE == SQLNOTFOUND)
	**	will be retrived.
	*/
	for (;;)
	{
		exec sql fetch c_demo3 into
			:car_no,
			:manufacturer,
			:cartype;
		if (SQLCODE == SQLNOTFOUND)
			break;
		rowcnt++;
		printf("%5ld  %s  %s\n",
			car_no,
			manufacturer,
			cartype);
	}

	printf("\n%d rows retrieved\n", rowcnt);

	/*
	**	Close the cursor
	*/
	exec sql close c_demo3;

	/*
	**	Close the database
	*/
	exec sql close database;

	/*
	**	Disconnect from database server
	*/
	exec sql disconnect;

	exit(0);
}
