/******************************************************************************
***
***				COPYRIGHT
***
***	Die Daten in dieser Datei sind Eigentum der 
***
***	YARD Software GmbH in 5000 Koeln 90, Deutschland.
***
***	Diese Datei gilt als Werk im Sinne des Urheberrechtsgesetzes und ist
***	damit urheberrechtlich geschuetzt. Jede Verwertung, insbesondere die
***	Vervielfaeltigung, Aenderung und Weitergabe, auch auszugsweise,
***	ist nur mit ausdruecklicher schriftlicher Genehmigung der YARD
***	Software GmbH zulaessig.
***
***	Ebenso ist die Speicherung dieser Datei auf Datentraegern wie z.B.
***	Festplatten, Disketten, Magnetbaendern, CDs und aehnlichen, auch 
***	auszugsweise, nur mit ausdruecklicher schriftlicher Genehmigung der 
***	YARD Software GmbH zulaessig.
***
***	Zuwiderhandlungen unterliegen den Strafbestimmungen des Urheberrechts-
***	gesetzes.
***
******************************************************************************/

#ifndef _SQLCC_H_
#define _SQLCC_H_

static char *sqlcc_h_sccsid = "@(#) sqlcc.h 4.6 98/11/05 16:44:41";

#ifndef NULL
#include <stdio.h>		/* 26.8.97		*/
#endif

/*
**	bitvalues for cursor flags
*/
#define	C_CLOSE 	0x02	/* cursor is closed 	  */
#define	C_INTO 		0x04	/* cursor has INTO clause */
#define	C_SCROLL 	0x08	/* scroll cursor 	  */
#define	C_HOLD    	0x10	/* cursor WITH HOLD	  */
#define	C_UNBUFFERED   	0x20	/* unbuffered cursor	  */
#define	C_LOCAL   	0x40	/* local cursor		  */
#define	C_GLOBAL   	0x80	/* global cursor	  */

/*
**	bitvalues for statement flags
*/
#define	S_LOCAL   	0x02	/* local stmt id		*/
#define	S_GLOBAL   	0x04	/* global stmt id		*/

/*
**	macros to assign values to hostarea structures
*/
#define YSQL_assign_area(hostval, hosttype, hostlen) \
	hostval.type = hosttype; \
	hostval.length = hostlen

#define YSQL_assign_data(hostval, hostvalue, hostind) \
	hostval.data = hostvalue; \
	hostval.indicator = hostind

/*
**	structure to manage ddl, dml and dcl statements
*/
typedef struct sqlstmt
{
	short sqlstype;			/* 	statement type 		*/
	union
	{
		char *sqlstmt;		/*	part of SQL statement	*/
		sqlha_t sqlval;		/*	hostarea structure to	*/
					/*	hold hostvars used in	*/
					/*	SQL statement		*/
	} sqlvalue;
} sqlstmt_t;

/*
**	defines for sqlstype
*/
#define STMTVALUE 	0x01
#define HOSTVALUE  	0x02

/*
**	defines to make the union transparant
*/
#define stmtvalue	sqlvalue.sqlstmt
#define hostvalue	sqlvalue.sqlval

/*
**	structure to manage SQL descriptor statements
*/
typedef struct descinfo
{
	short infotype;			/*	information type used in*/
					/*	GET & SET DESCRIPTOR	*/
	short itemtype;			/*	hostvar type used in	*/
					/*	GET & SET DESCRIPTOR	*/
	short itemlen;			/*	hostvar length used in	*/
					/*	GET & SET DESCRIPTOR	*/
	char *itemdata;			/*	pointer to data used in	*/
					/*	GET & SET DESCRIPTOR	*/
					
} descinfo_t;

/*
**	defines for infotype
*/
#define D_COUNT		  0		/*	GET & SET COUNT		*/
#define D_TYPE		  1		/*	GET & SET TYPE		*/
#define D_LENGTH	  2		/*	GET & SET LENGTH	*/
#define D_PRECISION	  3		/*	GET & SET PRECISION	*/
#define D_SCALE		  4		/*	GET & SET SCALE		*/
#define D_NULLABLE	  5		/*	GET NULLABLE		*/
#define D_INDICATOR	  6		/*	GET & SET INDICATOR	*/
#define D_DATA		  7		/*	GET & SET DATA		*/
#define D_NAME		  8		/*	GET NAME		*/
#define D_UNNAMED	  9		/*	GET UNNAMED		*/
#define D_RETURNED_LENGTH 10		/*	GET RETURNED_LENGTH	*/

/*
**	macros to assign values to descinfo structures
*/
#define YSQL_desc_info(infodesc, info_type, item_type, item_len) \
	infodesc.infotype = info_type; \
	infodesc.itemtype = item_type; \
	infodesc.itemlen = item_len

#define YSQL_desc_data(infodesc, infovalue) \
	infodesc.itemdata = infovalue

/*
**	defines for SELECT
*/
#define SINGLE_SELECT	1
#define DIRECT_SELECT	2
#define TEMP_SELECT	3

/*
**	defines for CREATE PROCEDURE/FUNCTION
*/
#define PROC_FROM_FILE	1
#define PROC_FROM_CHAR	2
#define PROC_FROM_TEXT	3

/*
**	defines for data type size
*/
#define CHAR_SIZE	(sizeof(char))
#define SHORT_SIZE	(sizeof(short))
#define INT_SIZE	(sizeof(int))
#define LONG_SIZE	(sizeof(long))
#define FLOAT_SIZE	(sizeof(float))
#define DOUBLE_SIZE   	(sizeof(double))
#define SERIAL_SIZE	(sizeof(long))
#define DATE_SIZE	(sizeof(long))
#define DECIMAL_SIZE	(sizeof(struct decimal))
#define MONEY_SIZE	(sizeof(double))
#define BLOB_SIZ 	(sizeof(struct blob))


#endif /* _SQLCC_H_ */
