/******************************************************************************
***
***				COPYRIGHT
***
***	Die Daten in dieser Datei sind Eigentum der 
***
***	YARD Software GmbH in 5000 Koeln 90, Deutschland.
***
***	Diese Datei gilt als Werk im Sinne des Urheberrechtsgesetzes und ist
***	damit urheberrechtlich geschuetzt. Jede Verwertung, insbesondere die
***	Vervielfaeltigung, Aenderung und Weitergabe, auch auszugsweise,
***	ist nur mit ausdruecklicher schriftlicher Genehmigung der YARD
***	Software GmbH zulaessig.
***
***	Ebenso ist die Speicherung dieser Datei auf Datentraegern wie z.B.
***	Festplatten, Disketten, Magnetbaendern, CDs und aehnlichen, auch 
***	auszugsweise, nur mit ausdruecklicher schriftlicher Genehmigung der 
***	YARD Software GmbH zulaessig.
***
***	Zuwiderhandlungen unterliegen den Strafbestimmungen des Urheberrechts-
***	gesetzes.
***
******************************************************************************/




/******************************************************************************
***
***	Defines for decimals in Client processes
***
******************************************************************************/

#ifndef _SQLDEC_H_
#define _SQLDEC_H_

static char *sqldec_h_sccsid = "@(#) sqldec.h 4.8 98/11/05 16:44:41";

#define MAXDECSIZE 16

struct decimal
{
	short dec_exp;			     /* Exponent (position of dot in */
					     /* dec_dgts)		     */
	short dec_pos;			     /* 0 = neg, 1 = pos , -1 = NULL */
	short dec_ndgts;		     /* Number of digits in dec_dgts */
	unsigned char dec_dgts[MAXDECSIZE];  /* digits of the decimal value  */
					     /* without dot.		     */
};

#ifndef CYGWIN32
typedef struct decimal DECIMAL;
#endif
typedef struct decimal decimal_t;

/*
**	Decimal prototypes
*/
int ba_deccmp(decimal_t *n1, decimal_t *n2);
int ba_decadd(decimal_t *n1, decimal_t *n2, decimal_t *res);
int ba_decsub(decimal_t *n1, decimal_t *n2, decimal_t *res);
int ba_decmul(decimal_t *n1, decimal_t *n2, decimal_t *res);
int ba_decdiv(decimal_t *n1, decimal_t *n2, decimal_t *res);
int ba_dectodbl(decimal_t *dp, double *dblp);
int ba_deccvdbl(double dbl, decimal_t *dp);
int ba_dectoflt(decimal_t *dp, float *fltp);
int ba_deccvflt(float flt, decimal_t *dp);
int ba_dectolong(decimal_t *dp, long *lp);
int ba_deccvlong(long l, decimal_t *dp);
int ba_dectoint(decimal_t *dp, int *ip);
int ba_deccvint(int i, decimal_t *dp);
int ba_dectoasc(decimal_t *dp, char *cp, int len, int right);
int ba_deccvasc(char *cp, int len, decimal_t *dp);

#endif /* _SQLDEC_H_ */
