/******************************************************************************
***
***				COPYRIGHT
***
***	Die Daten in dieser Datei sind Eigentum der 
***
***	YARD Software GmbH in 5000 Koeln 90, Deutschland.
***
***	Diese Datei gilt als Werk im Sinne des Urheberrechtsgesetzes und ist
***	damit urheberrechtlich geschuetzt. Jede Verwertung, insbesondere die
***	Vervielfaeltigung, Aenderung und Weitergabe, auch auszugsweise,
***	ist nur mit ausdruecklicher schriftlicher Genehmigung der YARD
***	Software GmbH zulaessig.
***
***	Ebenso ist die Speicherung dieser Datei auf Datentraegern wie z.B.
***	Festplatten, Disketten, Magnetbaendern, CDs und aehnlichen, auch 
***	auszugsweise, nur mit ausdruecklicher schriftlicher Genehmigung der 
***	YARD Software GmbH zulaessig.
***
***	Zuwiderhandlungen unterliegen den Strafbestimmungen des Urheberrechts-
***	gesetzes.
***
******************************************************************************/

#ifndef _SQLPROTO_H_
#define _SQLPROTO_H_

static char *sqlproto_h_sccsid = "@(#) sqlproto.h 4.7 98/11/05 16:44:42";

#include "sqlda.h"
#include "sqlcc.h"

/*
**	SQL prototypes
*/

extern long YSQL_db(char *, int);

extern long YSQL_createdb(char *, char *, int );

extern long YSQL_closedb(void);

extern long YSQL_dropdb(char *);

extern long YSQL_document(sqlstmt_t *, int, char *, int);

extern long YSQL_close(char *, int, int);

extern long YSQL_open(char *, sqlda_t *, char *, int, int, int);

extern long YSQL_fetch(char *, sqlda_t *, char *, int, long, int, int, int, 
	int);

extern long YSQL_select(sqlstmt_t *, int, sqlda_t *, int, int);

extern long YSQL_prepare(char *, char *, int, int);

extern long YSQL_declare(char *, char *, sqlstmt_t *, int, int, sqlda_t *, 
	int, int, int, int);

extern long YSQL_execute(char *, sqlda_t *, char *, sqlda_t *, char *, int,
	int, int, int, int);

extern long YSQL_immediate(char *);

extern long YSQL_free(char *, int, int, int);

extern long YSQL_alloc_desc(char *, long, int, int);

extern long YSQL_dealloc_desc(char *, int, int);

extern long YSQL_describe(char *, sqlda_t **, char *, int, int, int);

extern long YSQL_get_desc(char *, descinfo_t *, int, int, int, int, int);

extern long YSQL_set_desc(char *, descinfo_t *, int, int, int, int, int);

extern long YSQL_execstmt(sqlstmt_t *, int);

extern long YSQL_connect(char *, char *, char *);

extern long YSQL_disconnect(void);

extern long YSQL_commit(void);

extern long YSQL_rollback(char *);

extern void YSQL_stop(void);

extern int YSQL_error(void);

extern int YSQL_notfound(void);

extern int YSQL_warning(void);

extern long YSQL_create_prc(char *, int);

extern long YSQL_call(sqlstmt_t *, int, sqlda_t *, int);

/*
**	Basic prototypes for date functions
*/

extern int ba_sqldate(int);
extern int ba_date2long(char *);
extern int ba_convertdate(int, char *, char *);
extern int ba_day(int);
extern int ba_month(int);
extern int ba_year(int);
extern int ba_weekday(int);
extern int ba_isleapyear(int);

#endif /* _SQLPROTO_H_ */
