/*
   You may distribute under the terms of either the GNU General Public
   License or the Artistic License, as specified in the Perl README file.
*/

#include <DBIXS.h>

/* these are (almost) random values ! */
#define MAX_COLS 99
#define MAX_COL_NAME_LEN 99
#define MAX_BIND_VARS	99

#ifndef HDA_SIZE
#define HDA_SIZE 512
#endif

/* We need to define some Oracle typedefs too */
#define eb1 char
#define ub1 unsigned char
#define ub2 unsigned short
#define ub4 unsigned long
#define sb1 signed char
#define sb2 signed short
#define sb4 signed int
#define sword signed int

typedef struct imp_fbh_st imp_fbh_t;

struct imp_drh_st {
    dbih_drc_t com;         /* MUST be first element in structure   */
};

/* Define dbh implementor data structure */

struct imp_dbh_st
{
	dbih_dbc_t com;         /* MUST be first element in structure   */

	HDBC hdbc;
};

struct col
{
	char name[19];
	SWORD type;
	SWORD nullable;
};

#define	ISBLOB(t)	((t)==-4||(t)==-3)

/* Define sth implementor data structure */
struct imp_sth_st
{
	dbih_stc_t com;         /* MUST be first element in structure   */

	HSTMT hstmt;
	char cursorname[19];
	struct col *cinfo;


    /* Current row index? */

    int currow;
    int row_num;

    /* Input Details	*/
    char      *statement;   /* sql (see sth_scan)		*/
    HV        *bind_names;

    int is_insert;
    int is_create;
    int is_update;
    int is_drop;
    int is_delete;
    int is_select;

    /* Output Details	*/
    int        done_desc;   /* have we described this sth yet ?	*/
    int        done_execute;/** Have we executed this sth yet? */
    int        fbh_num;     /* number of output fields		*/
    imp_fbh_t *fbh;	    /* array of imp_fbh_t structs	*/
    char      *fbh_cbuf;    /* memory for all field names       */
    sb4   long_buflen;      /* length for long/longraw (if >0)	*/
    bool  long_trunc_ok;    /* is truncating a long an error	*/
};
#define IMP_STH_EXECUTING	0x0001


struct imp_fbh_st { 	/* field buffer EXPERIMENTAL */
    imp_sth_t *imp_sth;	/* 'parent' statement */


    SV	*sv;
};



typedef struct phs_st phs_t;    /* scalar placeholder   */


void    dbd_init _((dbistate_t *dbistate));

int     dbd_db_connect _((SV *dbh, char *host, char *dbname, char *junk));
int     dbd_db_commit _((SV *dbh));
int     dbd_db_rollback _((SV *dbh));
int     dbd_db_disconnect _((SV *dbh));
void    dbd_db_destroy _((SV *dbh));
int     dbd_db_STORE _((SV *dbh, SV *keysv, SV *valuesv));
SV      *dbd_db_FETCH _((SV *dbh, SV *keysv));

int     dbd_st_prepare _((SV *sth, char *statement, SV *attribs));
int     dbd_st_finish _((imp_sth_t *sth));
int     dbd_st_bindsv _((imp_sth_t *sth,int,SV*));
void    dbd_st_destroy _((imp_sth_t *sth));
AV    	*dbd_st_fetch _((imp_sth_t *sth));
int     dbd_st_STORE _((SV *sth, SV *keysv, SV *valuesv));
SV      *dbd_st_FETCH _((SV *sth, SV *keysv));


/* end */
